# -*- coding: utf-8 -*-
from PyQt6.QtCore import Qt, QSize
from PyQt6.QtWidgets import QMainWindow,QWidget, QPushButton, QStyle,QGraphicsDropShadowEffect, QComboBox, QFileDialog, QListView, QGridLayout, QLineEdit, QLabel, QTabWidget, QGroupBox, QVBoxLayout, QCheckBox, QHBoxLayout
from PyQt6.QtGui import QStandardItem, QIcon, QStandardItemModel, QColor
from pathlib import Path
from utils import Utils
import ressources

class OptionsOutput(QMainWindow):
    def __init__(self, application, parent=None,objectName=None):
        super().__init__(parent=parent)
        self.setObjectName(objectName)
        self.ut = Utils()
        self.enum_out_ext = QComboBox(objectName="enum_out_ext")
        self.enum_out_ext.addItems(self.ut.get_all_exts())
        self.placeholder1 = QLabel(" ")
        self.placeholder2 = QLabel(" ")
        self.layout_out = QVBoxLayout()
        self.layout_out.setObjectName("lay_Out")
        self.app = application
        self.out_group = QGroupBox("Output Options:")
        self.out_group.setProperty("subtab", "on")
        self.setCentralWidget(self.out_group)
        self.out_group.setFixedHeight(250)
        self.out_group.setLayout(self.layout_out)
        self.layout_out_line1 = QHBoxLayout()
        self.layout_out.addLayout(self.layout_out_line1)
        self.out_ext_label = QLabel("Extension:")
        self.layout_out_line1.addWidget(self.out_ext_label, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line1.addWidget(self.enum_out_ext, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line1.addWidget(self.placeholder2, Qt.AlignmentFlag.AlignLeft)
        self.out_ext_label.setFixedWidth(68)
        self.enum_out_ext.setFixedWidth(68)
        self.layout_out_line2 = QHBoxLayout()
        self.layout_out.addLayout(self.layout_out_line2)
        self.use_prefix = QCheckBox("Add prefix:",objectName="use_prefix")
        self.out_prefix = QLineEdit(objectName="out_prefix")
        self.out_prefix.setFixedWidth(120)
        self.use_prefix.setFixedWidth(100)
        self.placeholder5 = QLabel(" ")
        self.layout_out_line2.addWidget(self.use_prefix, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line2.addWidget(self.out_prefix, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line2.addWidget(self.placeholder5, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line3 = QHBoxLayout()
        self.layout_out.addLayout(self.layout_out_line3)
        self.use_suffix = QCheckBox("Add suffix:",objectName="use_suffix")
        self.out_suffix = QLineEdit("_converted",objectName="out_suffix")
        self.out_suffix.setFixedWidth(120)
        self.use_suffix.setFixedWidth(100)
        self.placeholder6 = QLabel(" ")
        self.layout_out_line3.addWidget(self.use_suffix, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line3.addWidget(self.out_suffix, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line3.addWidget(self.placeholder6, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line4 = QHBoxLayout()
        self.layout_out.addLayout(self.layout_out_line4)
        self.show_count = QCheckBox("Add Frame count",objectName="show_count")
        self.placeholder7 = QLabel(" ")
        self.layout_out_line4.addWidget(self.show_count, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line4.addWidget(self.placeholder7, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line6 = QHBoxLayout()
        self.layout_out.addLayout(self.layout_out_line6)
        self.dest_label = QLabel("Destination folder:")
        self.dest = QLineEdit(objectName="dest")
        self.dest_button = QPushButton()
        self.keep_origin_folder = QCheckBox("Same as origin folder",objectName="keep_origin_folder")
        self.placeholder9 = QLabel(" ")
        self.dest_label.setFixedWidth(150)
        self.dest.setFixedWidth(250)
        self.dest_button.setFixedWidth(26)
        self.layout_out_line6.addWidget(self.dest_label, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line6.addWidget(self.dest, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line6.addWidget(self.dest_button, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line6.addWidget(self.keep_origin_folder, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line6.addWidget(self.placeholder9, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line5 = QHBoxLayout()
        self.layout_out_line5.setObjectName("layout_out_line5")
        self.layout_out.addLayout(self.layout_out_line5)
        self.dest_button.setIcon(QIcon(":/folder.png"))
        self.layout_out_line7 = QHBoxLayout()
        self.layout_out.addLayout(self.layout_out_line7)
        self.still_vid_lbl = QLabel("Duration:")
        self.still_vid_duration = QLineEdit(objectName="still_vid_duration")
        self.frame_length_lbl = QLabel("Frames Length:")
        self.frame_length = QLineEdit(objectName="frame_length")
        self.still_vid_lbl.hide()
        self.still_vid_duration.hide()
        self.frame_length_lbl.hide()
        self.frame_length.hide()
        self.vid_from_img = QCheckBox("Slideshow from image(s)",objectName="vid_from_img")
        self.layout_out_line7.addWidget(self.vid_from_img,Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line7.addWidget(self.still_vid_lbl,Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line7.addWidget(self.still_vid_duration,Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line7.addWidget(self.frame_length_lbl,Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line7.addWidget(self.frame_length,Qt.AlignmentFlag.AlignLeft)
        self.still_vid_duration.setText("10")
        self.frame_length.setText("3")
        self.placeholder10 = QLabel(" ")
        self.layout_out_line7.addWidget(self.placeholder10,Qt.AlignmentFlag.AlignLeft)
        self.still_vid_duration.setFixedWidth(50)
        self.vid_from_img.setFixedWidth(150)
        self.still_vid_lbl.setFixedWidth(50)
        self.frame_length_lbl.setFixedWidth(75)
        self.frame_length.setFixedWidth(50)
        self.overwrite = QCheckBox("Overwrite existing filename",objectName="overwrite")
        self.placeholder8 = QLabel(" ")
        self.layout_out_line5.addWidget(self.overwrite, Qt.AlignmentFlag.AlignLeft)
        self.layout_out_line5.addWidget(self.placeholder8, Qt.AlignmentFlag.AlignLeft)

        self.layout_out_line8 = QHBoxLayout()
        self.disable_tdqm = QCheckBox("Disable progress bar")
        self.layout_out_line8.addWidget(self.disable_tdqm)
        self.layout_out.addLayout(self.layout_out_line8)

        attr_list = [self.dest_button,self.frame_length,self.frame_length_lbl,self.still_vid_duration,self.still_vid_lbl,self.vid_from_img, self.keep_origin_folder, self.overwrite, self.dest_label,self.dest, self.show_count, self.use_suffix, self.use_prefix, self.out_suffix, self.out_prefix, self.out_ext_label, self.enum_out_ext]
        self.set_shadows(attr_list)

    def set_shadows(self, attr_list):

        for attr in attr_list:
            effect = QGraphicsDropShadowEffect(self)
            effect.setBlurRadius(2)
            effect.setOffset(1, 2)
            effect.setColor(QColor(16, 16, 16, 64))
            attr.setGraphicsEffect(effect)

